unit dmTest;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, DB;

const
  cTABLE1 = 'table1.dat';

type

  { TDataModuleTest }

  TDataModuleTest = class(TDataModule)
    BufDataset1: TBufDataset;
    DSLookup: TDataSource;
    TLookup: TBufDataset;
    DataSource1: TDataSource;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    procedure PrepareTables;
    //procedure PrepareLookupData;
  public
    procedure Initialize;
    procedure InitializeWithData;
    procedure PrepareData;
    procedure SafeDataToFiles;
    procedure LoadDataFromFiles;
  end;

var
  DataModuleTest: TDataModuleTest;

implementation

uses
   Dialogs, Controls
  //,Printers
  ,LR_Prntr
  ;

{$R *.lfm}

{ TDataModuleTest }

procedure TDataModuleTest.DataModuleCreate(Sender: TObject);
begin
  Initialize;
end;

procedure TDataModuleTest.DataModuleDestroy(Sender: TObject);
begin
  //if MessageDlg('Safe Data to Files?', mtConfirmation, [mbYes, mbNo],0) = mrYes then
  //  SafeDataToFiles;
end;

procedure TDataModuleTest.PrepareTables;
begin

  BufDataset1.Close;
  BufDataset1.Clear;    // Will close and remove all field definitions.

  with BufDataset1.FieldDefs do
  begin
    Clear;              //We dont need this line, but it does not hurt either.
    Add('ID', ftInteger, 0, False);
    Add('DESCRIPCION', ftString, 20, False);
    Add('PageFormatA', ftString, 50, False);
    Add('PageFormatB', ftString, 50, False);
    Add('PageFormatLookup', ftString, 50, False);
    Add('Orientation_String', ftString, 50, False);
    Add('Orientation_Int', ftInteger, 0, False);
    Add('NUMBER_A', ftInteger, 0, False);
    Add('NUMBER_B', ftInteger, 0, False);
  end;
  BufDataset1.CreateDataset;
  BufDataset1.Open;

  TLookup.Close;
  TLookup.Clear;    // Will close and remove all field definitions.

  with TLookup.FieldDefs do
  begin
    Clear;              //We dont need this line, but it does not hurt either.
    Add('PaperID', ftInteger, 0, False);
    Add('Name', ftString, 50, False);
    Add('NameLong', ftString, 100, False);
    Add('Typ', ftInteger, 0, False);
    Add('X', ftInteger, 0, False);
    Add('Y', ftInteger, 0, False);
  end;
  TLookup.CreateDataset;
  TLookup.Open;


end;

//procedure TDataModuleTest.PrepareLookupData;
//var
//  i:integer;
//  frptr:TfrPrinter;
//begin
//  try
//    frptr:=TfrPrinter.Create;
//    //for i:=0 to PAPERCOUNT -1 do begin
//    //   LR_Prntr.Prn.FillPapers();
//    //end;
//  finally
//    frptr.free;
//  end;
//end;

procedure TDataModuleTest.Initialize;
begin
  PrepareTables;
end;

procedure TDataModuleTest.InitializeWithData;
begin
  PrepareTables;
  PrepareData;
end;

procedure TDataModuleTest.PrepareData;
Var
  i:integer;
begin
  If Fileexists(cTABLE1) then
    BufDataset1.LoadFromFile(cTABLE1)
  else begin
    For i:=1 to 10 do begin
      BufDataset1.Append;
      BufDataset1.FieldByName('ID').AsInteger := i;
      BufDataset1.FieldByName('DESCRIPCION').AsString := 'Name_'+inttostr(i);
      BufDataset1.FieldByName('PageFormatA').AsString := 'PageFormatA_'+inttostr(i);
      BufDataset1.FieldByName('NUMBER_A').AsInteger := 100+i;
      BufDataset1.FieldByName('NUMBER_B').AsInteger := 200+i;
      BufDataset1.Post;
    end;
  end;

  //PrepareLookupData;

end;

procedure TDataModuleTest.SafeDataToFiles;
begin
  BufDataset1.SaveToFile(cTABLE1);
end;

procedure TDataModuleTest.LoadDataFromFiles;
begin
  If Fileexists(cTABLE1) then
    BufDataset1.LoadFromFile(cTABLE1);
end;


end.

